' simple hatband code for HL1606 LED strips
' john cohn johncohn@us.ibm.com 802-578-0985

' 6/18/09 fixed unchecked constant size bug reported by roman

' constants for D input .. bright colors
symbol red = %10000001
symbol yellow = %10000101
symbol green = %10000100
symbol aqua = %10010100
symbol blue = %10010000
symbol white = %10010101
symbol purple = %10010001
symbol black = %10000000


' constants for D input .. half-bright colors
symbol dred = %10000010
symbol dyellow = %10001010
symbol dgreen = %10001000
symbol daqua = %10101000
symbol dblue = %10100000
symbol dwhite = %10101010
symbol dpurple = %10100010

' Map some local variables 


symbol color = b0     	' b0 color
symbol leds = b2		' b2 number of leds in a pattern 
symbol time = b3		' b3 duration of event in ms 
symbol tcolor = b4 	' b4 temporary color storage fror bit shifting
symbol i = b1		' bi iterator i
symbol j = b5		' b5 iterator j
symbol l = b7		' b7 iterator l
symbol m = b8		' b8 iterator m
symbol l1 = b6		' b6 number of leds of col1 in two color pattern 
symbol l2 = b11		' b11 number of leds of col2 in two color pattern 
symbol col1 = b9		' b9  color 1 of two color pattern
symbol col2 = b10		' b10  color 2 of two color pattern
symbol r1 = b12		' b12 storage for random function 1
symbol r2 = b13		' b13 storage for random function 2

' Pin numbers

symbol DI = 1		' pin 1 di	
symbol CI = 2		' pin 2 ci
symbol LI = 4		' pin 4 li
symbol SI = 0		' pin 0 si

' Set as outputs

output DI 			' output data 
output CI			' output clock
output LI			' output latch
output SI			' output pwm duty cycle thingy


' load color arrays
	poke 80,black
	poke 81,red
	poke 82,yellow
	poke 83,green
	poke 84,aqua
	poke 85,blue
	poke 86,purple
	poke 87,white

main:

time = 20		' set speed
gosub rainbow	' simple rainbow wash

l1 = 1		' 1 LED on
l2 = 20		' followed by 20 black (or off) 
col2 = black
 
gosub rchase	' simple rainbow  chase


gosub ran		' run a few random color chases 

l1 = 4		' simple patern of 4 of col1 
l2 = 16		' .. and 16 of col 2 
gosub rchase	

time = 10		' another simple rainbow
gosub rainbow


goto main 		 loop back to start

rainbow:				' simple rainbow wash 
	for l = 1 to 4 		' do it 4 times
		let leds = 6	' 6 leds per color 
		for j = 81 to 87 	' walk through the colors in meory and load them
			peek j, color
			gosub blink	' push them into the strip
		next j
	next l 
return


rchase:		' simple single color rainbow chase  
	
	for l = 1 to 4 			' do it 4 times
		for j = 81 to 87 		'  walk through the colors in meory and load them
			peek j, col1	' load up each color in col1 (col2 is generally black at this point)
			gosub chase		' call the two color chase
		next j
	next l 
return

chase:		' simple 2 color chase. allows selection of 2 colors . col1, col2 and 
			' and number of leds of each l1,l2
	color = col1	
	leds =l1
	gosub blink
	leds  = l2
	color = col2
	gosub blink
return


ran:			' crufty random led effects.. chooses two differnt lenghts, two different colors
			' and runs them as a pattern 
w6 = 12345

for l = 1 to 4
	random w6
	l1  = r1 & %00001111
	random w6
	l2  = r2 & %00001111
	random w6
	col1 =  r1 & %00000111
	col1 = 80 + col1
	peek col1, col1
	random w6
	col2 = r2 & %00000111
	col2 = 80 + col2
	peek col2, col2
	gosub chase
next l
return

blink:	' run the specific psattern for number of specified leds 
	for i = 1 to leds
		gosub spiout	' shift data via SPI bus
		pause time		' wait proscribed delay
	next i
	return



spiout:				' dump the data to the HL1606
	let tcolor = color	' start by grabbing the color into tcolor 
	for m = 1 to 8		' walk through all the bits and shift them sequentially to the left
		if tcolor <= 127 then spil 	' if the MSB is high then 
							' pulse the data high with a clock high pulse in the middle
		high DI
		high CI
		low CI
		low DI
		goto spih
spil:							' else the msb is low. just do an empty clock pulse

		high CI
		low CI
spih:							

	let tcolor = tcolor * 2			' shift it left
	next m
	high LI					' when your done with all 8 bits, pulse the latch high
	low LI
return